---
title: Caching compiled WebAssembly modules
slug: WebAssembly/Caching_modules
tags:
  - Caching
  - IndexedDB
  - JavaScript
  - Module
  - WebAssembly
  - compile
  - wasm
---
<div>{{WebAssemblySidebar}}</div>

<div class="warning">
<p><strong>Warning</strong>: Experimental {{jsxref("WebAssembly.Module")}} IndexedDB serialization support is being removed from browsers; see {{bug("1469395")}} and <a href="https://github.com/WebAssembly/spec/issues/821">this spec issue</a>.</p>
</div>

<p class="summary">Caching is useful for improving the performance of an app — we can store compiled WebAssembly modules on the client so they don't have to be downloaded and compiled every time. This article explains the best practices around this.</p>

<h2 id="Caching_via_IndexedDB">Caching via IndexedDB</h2>

<p><a href="/en-US/docs/Web/API/IndexedDB_API">IndexedDB</a> is a transactional database system that allows you to store and retrieve structured data on the client-side. It is ideal for persisting assets locally for the saved state of an application, including text, blobs, and any other type of cloneable object.</p>

<p>This includes compiled wasm modules ({{jsxref("WebAssembly.Module")}} JavaScript objects).</p>

<h2 id="Setting_up_a_caching_library">Setting up a caching library</h2>

<p>Because IndexedDB is a somewhat old-fashioned API, we wanted to provide a library function to speed up writing caching code, and make it work better along with today's more modern APIs.</p>

<p>In our wasm-utils.js library script, you'll find <code>instantiateCachedURL()</code> — this function fetches the wasm module at <code>url</code> with a version of <code>dbVersion</code>, instantiates it with the given <code>importObject</code>, and returns a promise resolving to the finished wasm Instance. Additionally, it handles creating a database to cache the compiled wasm modules in, attempts to store new modules in the database, and retrieves previously cached modules from the database, saving you from having to download them again.</p>

<div class="note">
<p><strong>Note</strong>: The entire site's wasm cache (not just the given URL) is versioned by the specified <code>dbVersion</code> passed into the function. If the wasm module code is updated, or its URL changes, you will need to update <code>dbVersion</code>. Any subsequent call to <code>instantiateCachedURL()</code> will then clear out the entire cache, allowing you to avoid using out-of-date modules.</p>
</div>

<p>The function starts off by defining some necessary constants:</p>

<pre class="brush: js notranslate">function instantiateCachedURL(dbVersion, url, importObject) {
  const dbName = 'wasm-cache';
  const storeName = 'wasm-cache';</pre>

<h3 id="Setting_up_the_database">Setting up the database</h3>

<p class="brush: js">The first helper function contained inside <code>instantiateCachedURL()</code> — <code>openDatabase()</code> — creates an object store for storing wasm modules, and also handles clearing out the database if the <code>dbVersion</code> is updated; it returns a promise resolving to the new database.</p>

<pre class="brush: js notranslate">  function openDatabase() {
    return new Promise((resolve, reject) =&gt; {
      var request = indexedDB.open(dbName, dbVersion);
      request.onerror = reject.bind(null, 'Error opening wasm cache database');
      request.onsuccess = () =&gt; { resolve(request.result) };
      request.onupgradeneeded = event =&gt; {
        var db = request.result;
        if (db.objectStoreNames.contains(storeName)) {
            console.log(`Clearing out version ${event.oldVersion} wasm cache`);
            db.deleteObjectStore(storeName);
        }
        console.log(`Creating version ${event.newVersion} wasm cache`);
        db.createObjectStore(storeName)
      };
    });
  }</pre>

<h3 id="Looking_up_modules_in_the_database">Looking up modules in the database</h3>

<p>Our next function — <code>lookupInDatabase()</code> — provides a simple promise-based operation for looking up the given <code>url</code> in the object store we created above. It resolves with the stored compiled module, or rejects with an error.</p>

<pre class="brush: js notranslate">  function lookupInDatabase(db) {
    return new Promise((resolve, reject) =&gt; {
      var store = db.transaction([storeName]).objectStore(storeName);
      var request = store.get(url);
      request.onerror = reject.bind(null, `Error getting wasm module ${url}`);
      request.onsuccess = event =&gt; {
        if (request.result)
          resolve(request.result);
        else
          reject(`Module ${url} was not found in wasm cache`);
      }
    });
  }</pre>

<h3 id="Storing_and_instantiating_modules">Storing and instantiating modules</h3>

<p>Next, we define a function <code>storeInDatabase()</code> that fires off an async operation to store a given wasm module in a given database.</p>

<pre class="brush: js notranslate">  function storeInDatabase(db, module) {
    var store = db.transaction([storeName], 'readwrite').objectStore(storeName);
    var request = store.put(module, url);
    request.onerror = err =&gt; { console.log(`Failed to store in wasm cache: ${err}`) };
    request.onsuccess = err =&gt; { console.log(`Successfully stored ${url} in wasm cache`) };
  }</pre>

<h3 id="Using_our_helper_functions">Using our helper functions</h3>

<p>With all the Promise-based helper functions defined, we can now express the core logic of an IndexedDB cache lookup. We start by trying to open a database, then see if we already have a compiled Module with the key <code>url</code> stored in the given <code>db</code>:</p>

<pre class="brush: js notranslate">  return openDatabase().then(db =&gt; {
    return lookupInDatabase(db).then(module =&gt; {</pre>

<p>If we do, we instantiate it with the given import object:</p>

<pre class="brush: js notranslate">      console.log(`Found ${url} in wasm cache`);
      return WebAssembly.instantiate(module, importObject);
    },</pre>

<p>If not, we compile it from scratch and then store the compiled Module in the database with a key of url, for next time we want to use it:</p>

<pre class="brush: js notranslate">    errMsg =&gt; {
      console.log(errMsg);
      return WebAssembly.instantiateStreaming(fetch(url)).then(results =&gt; {
        storeInDatabase(db, results.module);
        return results.instance;
      });
    })
  },</pre>

<div class="note">
<p><strong>Note</strong>: It is for this kind of usage that {{jsxref("WebAssembly.instantiate()")}} returns both a {{jsxref("WebAssembly.Module()", "Module")}} and an {{jsxref("WebAssembly.Instance()", "Instance")}}: the Module represents the compiled code and can be stored/retrieved in IDB or shared between Workers via <code><a href="/en-US/docs/Web/API/MessagePort/postMessage">postMessage()</a></code>; the Instance is stateful and contains the callable JavaScript functions, therefore it cannot be stored/shared.</p>
</div>

<p>If opening the database failed (for example due to permissions or quota), we fall back to fetching and compiling the module and don't try to store the results (since there is no database to store them into).</p>

<pre class="brush: js notranslate">  errMsg =&gt; {
    console.log(errMsg);
    return WebAssembly.instantiateStreaming(fetch(url)).then(results =&gt; {
      return results.instance
    });
  });
}</pre>

<h2 id="Caching_a_wasm_module">Caching a wasm module</h2>

<p>With the above library function defined, getting a wasm module instance and using its exported features (while handling caching in the background) is as simple as calling it with the following parameters:</p>

<ul>
 <li>A cache version, which — as we explained above — you need to update when any wasm module is updated or moved to a different URL.</li>
 <li>The URL of the wasm module you want to instantiate.</li>
 <li>An import object, if required.</li>
</ul>

<pre class="brush: js notranslate">const wasmCacheVersion = 1;

instantiateCachedURL(wasmCacheVersion, 'test.wasm').then(instance =&gt;
  console.log("Instance says the answer is: " + instance.exports.answer())
).catch(err =&gt;
  console.error("Failure to instantiate: " + err)
);</pre>

<p>You can find the source code for this example on GitHub as <a href="https://github.com/mdn/webassembly-examples/blob/master/other-examples/indexeddb-cache.html">indexeddb-cache.html</a> (<a href="https://mdn.github.io/webassembly-examples/other-examples/indexeddb-cache.html">see it live also</a>).</p>

<h2 id="Browser_support">Browser support</h2>

<p>At the moment, this technique will work in Firefox and Edge, as they both have support for structured cloning of WebAssembly modules.</p>

<p>Chrome has support implemented behind the <em>WebAssembly structured cloning support</em> flag, but is yet to turn it on by default because of some concerns (<a href="https://github.com/WebAssembly/design/issues/972">see this discussion</a>, for example).</p>

<p>Safari is still yet to implement.</p>
